package com.ruoyi.clock.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.ruoyi.clock.exception.ProductExceptionEnum;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.BeanCopyUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.clock.domain.bo.ProductBo;
import com.ruoyi.clock.domain.vo.ProductVo;
import com.ruoyi.clock.domain.Product;
import com.ruoyi.clock.mapper.ProductMapper;
import com.ruoyi.clock.service.IProductService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 产品信息Service业务层处理
 *
 * @author pengc
 * @date 2026-03-04
 */
@RequiredArgsConstructor
@Service
public class ProductServiceImpl implements IProductService {

    private final ProductMapper baseMapper;

    /**
     * 查询产品信息分页
     *
     * @param bo 产品信息
     * @return 产品信息
     */
    @Override
    public TableDataInfo<ProductVo> queryPageList(ProductBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<Product> lqw = buildQueryWrapper(bo);
        Page<ProductVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询产品信息列表
     *
     * @param bo 产品信息
     * @return 产品信息
     */
    @Override
    public List<ProductVo> queryList(ProductBo bo) {
        LambdaQueryWrapper<Product> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<Product> buildQueryWrapper(ProductBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<Product> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getProductName()), Product::getProductName, bo.getProductName());
        return lqw;
    }

    /**
     * 查询产品信息
     *
     * @param productId 产品信息主键
     * @return 产品信息
     */
    @Override
    public ProductVo queryById(Long productId){
        return baseMapper.selectVoById(productId);
    }

    /**
     * 详情产品信息
     *
     * @param productId 产品信息主键
     * @return 产品信息
     */
    @Override
    public Product loadById(Long productId, Boolean tw){
        Product info = this.baseMapper.selectById(productId);
        if(ObjectUtil.isEmpty(info) && tw){
            throw new ServiceException(ProductExceptionEnum.PRODUCT_IS_NOT_EXISTS);
        }
        return info;
    }

    /**
     * 新增产品信息
     *
     * @param bo 产品信息
     * @return 结果
     */
    @Override
    public Boolean insertByBo(ProductBo bo) {
        Product add = BeanUtil.toBean(bo, Product.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setProductId(add.getProductId());
        }
        return flag;
    }

    /**
     * 修改产品信息
     *
     * @param bo 产品信息
     * @return 结果
     */
    @Override
    public Boolean updateByBo(ProductBo bo) {
        Product product = baseMapper.selectById(bo.getProductId());
        Product update = BeanCopyUtils.copy(bo, product);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Product entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除产品信息
     *
     * @param ids 需要删除的产品信息主键
     * @return 结果
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

}
